'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactImageFallback = require('react-image-fallback');

var _reactImageFallback2 = _interopRequireDefault(_reactImageFallback);

var _no_image = require('./no_image.png');

var _no_image2 = _interopRequireDefault(_no_image);

var _loading = require('./loading.gif');

var _loading2 = _interopRequireDefault(_loading);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function FileImage(props) {
    var src = props.src,
        alt = props.alt,
        style = props.style,
        onClick = props.onClick;


    return _react2.default.createElement(_reactImageFallback2.default, {
        onClick: onClick,
        src: src,
        fallbackImage: _no_image2.default,
        initialImage: _loading2.default,
        alt: alt,
        style: style
    });
}

FileImage.defaultProps = {
    src: '',
    alt: '',
    style: {}
};

FileImage.propTypes = process.env.NODE_ENV !== "production" ? {
    src: _propTypes2.default.string.isRequired,
    alt: _propTypes2.default.string,
    style: _propTypes2.default.object,
    onClick: _propTypes2.default.func
} : {};

exports.default = FileImage;
module.exports = exports['default'];